// another fine solution by misof
#include <algorithm>
#include <vector>
#include <cstdio>
using namespace std;

#define MAX 1234567

int N, M, K;
int color[MAX];
vector< vector<int> > members;
int E[MAX][2];
int D[MAX];
int damaged[MAX];
int components;
int answer[MAX];

void join(int x, int y) {
  if (color[x]==color[y]) return;
  --components;
  vector<int> &A = members[ color[x] ];
  vector<int> &B = members[ color[y] ];
  if (A.size() < B.size()) {
    for (int i=0; i<int(A.size()); ++i) {
      color[ A[i] ] = color[y];
      B.push_back( A[i] );
    }
    A.clear();
  } else {
    for (int i=0; i<int(B.size()); ++i) {
      color[ B[i] ] = color[x];
      A.push_back( B[i] );
    }
    B.clear();
  }
}

int main() {
  freopen("hurikan.in", "r", stdin);
  freopen("hurikan.out", "w", stdout);
  scanf("%d%d",&N,&M);
  components = N;
  members.resize(N+1);
  for (int n=1; n<=N; ++n) members[n].push_back(n);
  for (int n=1; n<=N; ++n) color[n] = n;
  for (int m=1; m<=M; ++m) scanf("%d%d",&E[m][0],&E[m][1]);
  scanf("%d",&K);
  for (int k=1; k<=K; ++k) { scanf("%d",&D[k]); damaged[D[k]]=1; }
  for (int m=1; m<=M; ++m) if (!damaged[m]) join(E[m][0],E[m][1]);
  answer[0] = components-1;
  for (int k=K; k>=1; --k) { join(E[D[k]][0],E[D[k]][1]); answer[K+1-k]=components-1; }
  for (int k=K; k>=0; --k) printf("%d\n",answer[k]);
}
